package com.lantone.qc.kernel.catalogue.behospitalized;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.kernel.util.CatalogueUtil;
import com.lantone.qc.kernel.util.RedisUtil;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.util.ListUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @Description: 传染病史未填写
 * @author: rengb
 * @time: 2020/3/10 14:02
 */
@Component
public class BEH0030 extends QCCatalogue {

    @Autowired
    private RedisUtil redisUtil;

    @Override
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        if (ListUtil.isNotEmpty(
                CatalogueUtil.filterDiagsByNature(
                        inputInfo.getBeHospitalizedDoc().getPastLabel().getDiags(),
                        "infectious",
                        "1"
                )
        )) {
            status = "0";
        }
    }

}