package com.lantone.qc.kernel.catalogue.behospitalized;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.entity.Address;
import com.lantone.qc.pub.util.ListUtil;
import com.lantone.qc.pub.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 居住地未描述
 * @author: rengb
 * @time: 2020/3/10 14:02
 */
@Component
public class BEH0043 extends QCCatalogue {

    @Override
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        List<Address> addresses = inputInfo.getBeHospitalizedDoc().getPersonalLabel().getAddresses();
        if (ListUtil.isNotEmpty(addresses)) {
            long count = addresses.stream().map(i -> i.getName()).filter(i -> StringUtil.isNotBlank(i) && i.indexOf("居住") != -1).count();
            if (count > 0) {
                status = "0";
            }
        }
    }

}