package com.lantone.qc.trans.changx;

import com.lantone.qc.pub.model.doc.BeHospitalizedDoc;
import com.lantone.qc.pub.model.keys.ModelStandardKeys;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.pub.util.ListUtil;
import com.lantone.qc.pub.util.StringUtil;
import com.lantone.qc.trans.ModelDocTrans;

import java.util.Map;

/**
 * @Description: 入院记录文档生成
 * @author: rengb
 * @time: 2020/3/5 15:47
 */
public class BeHospitalizedDocTrans extends ModelDocTrans {

    public BeHospitalizedDoc extract(MedrecVo medrecVo) {
        String content = medrecVo.getContent().get("content").toString();
        int index1 = content.indexOf("初步诊断") + 5;
        int index2 = content.indexOf("修正诊断") - 1;
        content = content.substring(0, index1)
                + StringUtil.specialCharComma(content.substring(index1, index2))
                + content.substring(index2);

        Map<String, String> structureMap =
                getPreproc().extract_doc_pub(
                        false,
                        ListUtil.isEmpty(medrecVo.getLabel()) ? ModelStandardKeys.beHospitalized : medrecVo.getLabel(),
                        content
                );

        structureMap.put("体格检查", structureMap.get("体格检查（一）"));
        structureMap.put("专科体格检查", structureMap.get("体格检查（二）"));
        structureMap.remove("体格检查（一）");
        structureMap.remove("体格检查（二）");

        return getModelDocGenerate().beHospitalizedDocGen(structureMap);
    }

}